#include "lex.yy.c"
#include "sourcereader.hh"

#define OPTARGS_CHECK_GET(wrong,right) lokke==argc-1?(fprintf(stderr,"Must supply argument for '%s'\n",argv[lokke]),exit(-4),wrong):right

#define OPTARGS_BEGIN(das_usage) {int lokke;const char *usage=das_usage;for(lokke=1;lokke<argc;lokke++){char *a=argv[lokke];if(!strcmp("--help",a)||!strcmp("-h",a)){fprintf(stderr,usage);exit(0);
#define OPTARG(name,name2) }}else if(!strcmp(name,a)||!strcmp(name2,a)){{
#define OPTARG_GETINT() OPTARGS_CHECK_GET(0,atoi(argv[++lokke]))
//int optargs_inttemp;
//#define OPTARG_GETINT() OPTARGS_CHECK_GET(0,(optargs_inttemp=strtol(argv[++lokke],(char**)NULL,10),errno!=0?(perror("strtol"),0):optargs_inttemp))
#define OPTARG_GETFLOAT() OPTARGS_CHECK_GET(0.0f,atof(argv[++lokke]))
#define OPTARG_GETSTRING() OPTARGS_CHECK_GET("",argv[++lokke])
#define OPTARG_LAST() }}else if(lokke==argc-1 && argv[lokke][0]!='-'){lokke--;{
#define OPTARGS_ELSE() }else if(1){
#define OPTARGS_END }else{fprintf(stderr,usage);exit(-1);}}}


int main(int argc, char**argv){
  const char *infile=NULL;
  const char *outfile=NULL;
  const char *help=
    "impfaust [--input inputfile] [--output outputfile] [--version]\n"
    "         [ -i     inputfile] [ -o      outputfile] [ -v      ]\n";
  OPTARGS_BEGIN(help)
    {
      OPTARG("--input","-i")   infile=OPTARG_GETSTRING();
      OPTARG("--output","-o") outfile=OPTARG_GETSTRING();
      OPTARG("--version","-v") puts(VERSION);exit(0);
    }OPTARGS_END;

  if(infile==NULL || outfile==NULL){
    fprintf(stderr,help);
    exit(-1);
  }

  yyin = fopen( infile, "r" );

  const char *tempfile = "/tmp/impfaust_lexed.lsp";

  FILE *out=fopen(tempfile,"w");

  fprintf(out,"(DEFUN GET-LEXLIST () (LIST\n");

  int r;
  do{
    r=yylex();
    //printf("%d %d %d\t%d:\t%s\n",r,r==DEF,r==IDENT,yylineno,yytext);
    if(r==0)
      break;
    if(yytext[0]=='"')
      fprintf(out,"%d 'string %s\n",yylineno,yytext);
    else
      fprintf(out,"%d \"%s\"\n",yylineno,yytext);
  }while(true);

  fprintf(out,"))\n");

  fclose(out);

  {
    char command[5000];
    sprintf(command,"%s_compiler %s %s",argv[0], tempfile, outfile);    
    system(command);
    unlink(tempfile);
  }

  return 0;
}
